import {select, 
        csv, 
        scaleLinear, 
        max, 
        scaleBand,
        axisLeft,
       	axisBottom
       } from "d3";


const svg = select('svg');
  const height = +svg.attr('height');
  const width = +svg.attr('width');

const render = data => {
  const xValue = d => d.population;
  const yValue = d => d.country;
	const margin = {
  	left: 100,
    right: 20,
    bottom: 20,
    top: 20
  }
  const innerWidth = width - margin.left - margin.right;
	const innerHeight = height - margin.bottom - margin.top ;
  
  const xScale = scaleLinear()
  	.domain([0,max(data, xValue)])
  	.range([0, innerWidth]);  
  
  
  
  const yScale = scaleBand ()
  	.domain(data.map(yValue))
  	.range([0, innerHeight])
  	.padding(0.1);
  

  const g = svg.append("g")
	.attr("transform",`translate(${margin.left},${margin.right})`)
  
  //const yAxis = axisLeft(yScale); we can use it directly in call func
  //yAxis(g.append('g'));
  //shorthand
  g.append("g").call(axisLeft(yScale));
  g.append("g").call(axisBottom(xScale))
  	.attr("transform",`translate(0, ${innerHeight})`)

	 g
  	.selectAll("rect").data(data)
  	.enter().append("rect")
  		.attr("y", d => yScale(yValue(d)))
  		.attr("width", d => xScale(xValue(d)))
  		.attr("height",d => yScale.bandwidth())
}

 csv("data.csv").then(data => {
   data.forEach(d => {
    	d.population = +d.population * 1000 // parseFloat shorthand
   })
 		render(data);
 })
  


